Index: /branches/prototype-v0/zoo-project/zoo-kernel/ZOOMakefile.opts.in
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 854)
@@ -115,5 +115,5 @@
 
 CFLAGS=@SSH2_CPPFLAGS@ @GETTEXT_CFLAGS@ @PROJ_CPPFLAGS@ @RELY_ON_DB@ @DEB_DEF@ -fpic @OPENSSL_CFLAGS@ @UUID_CFLAGS@ ${FCGI_CFLAGS} ${YAML_CFLAGS} ${MACOS_CFLAGS} ${MS_CFLAGS} -I../../thirds/cgic206 -I. -DLINUX_FREE_ISSUE #-DDEBUG #-DDEBUG_SERVICE_CONF
-LDFLAGS=-lzoo_service @SSH2_LDFLAGS@ @PROJ_LDFLAGS@ @DEFAULT_LIBS@ -L../../thirds/cgic206 -lcgic ${GDAL_LIBS} ${XML2LDFLAGS} ${PYTHONLDFLAGS} ${PERLLDFLAGS}  ${PHPLDFLAGS} ${JAVALDFLAGS} ${JSLDFLAGS}  ${FCGI_LDFLAGS} @OPENSSL_LDFLAGS@ @UUID_LDFLAGS@ ${MS_LDFLAGS} ${MACOS_LD_FLAGS} ${MACOS_LD_NET_FLAGS} ${YAML_LDFLAGS} ${OTBLDFLAGS} ${SAGA_LDFLAGS} ${MONO_LDFLAGS} @GETTEXT_LDFLAGS@ @JSON_LDFLAGS@
+LDFLAGS=-lzoo_service @SSH2_LDFLAGS@ @PROJ_LDFLAGS@ @DEFAULT_LIBS@ -L../../thirds/cgic206 -lcgic ${GDAL_LIBS} ${XML2LDFLAGS} ${PYTHONLDFLAGS} ${PERLLDFLAGS}  ${PHPLDFLAGS} ${JAVALDFLAGS} ${JSLDFLAGS}  ${FCGI_LDFLAGS} @OPENSSL_LDFLAGS@ @UUID_LDFLAGS@ ${MS_LDFLAGS} ${MACOS_LD_FLAGS} ${MACOS_LD_NET_FLAGS} ${YAML_LDFLAGS} ${OTBLDFLAGS} ${SAGA_LDFLAGS} ${MONO_LDFLAGS} @GETTEXT_LDFLAGS@ @JSON_LDFLAGS@ @XSLT_LDFLAGS@
 
 DATAROOTDIR=@datarootdir@/zoo-project
Index: /branches/prototype-v0/zoo-project/zoo-kernel/caching.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/caching.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/caching.c	(revision 854)
@@ -64,4 +64,70 @@
 
 /**
+ * Create a URL by appending every request header listed in the security 
+ * section.This imply that the URL will contain any authentication 
+ * informations that should be fowarded to the server from which de input
+ * was download.
+ * @param conf the main configuration maps
+ * @param request the URL to transform.
+ * @return a char* that contain the original URL plus potential header (only for
+ * hosts that are not shared).
+ * @warning Be sure to free the memory returned by this function.
+ */
+char* getFilenameForRequest(maps* conf, const char* request){
+  map* passThrough=getMapFromMaps(conf,"security","attributes");
+  map* targetHosts=getMapFromMaps(conf,"security","hosts");
+  char* passedHeader[10];
+  int cnt=0;
+  char *res=zStrdup(request);
+  char *toAppend=NULL;
+  if(passThrough!=NULL && targetHosts!=NULL){
+    char *tmp=zStrdup(passThrough->value);
+    char *token, *saveptr;
+    token = strtok_r (tmp, ",", &saveptr);
+    int i;
+    if((strstr(targetHosts->value,"*")!=NULL || isProtectedHost(targetHosts->value,request)==1) && strncasecmp(getProvenance(conf,request),"SHARED",6)!=0){
+      while (token != NULL){
+	int length=strlen(token)+6;
+	char* tmp1=(char*)malloc(length*sizeof(char));
+	map* tmpMap;
+	snprintf(tmp1,6,"HTTP_");
+	int j;
+	for(j=0;token[j]!='\0';j++){
+	  if(token[j]!='-')
+	    tmp1[5+j]=toupper(token[j]);
+	  else
+	    tmp1[5+j]='_';
+	  tmp1[5+j+1]='\0';
+	}
+	tmpMap = getMapFromMaps(conf,"renv",tmp1);
+	if(tmpMap!=NULL){
+	  if(toAppend==NULL){
+	    toAppend=(char*)malloc((strlen(tmpMap->value)+1)*sizeof(char));
+	    sprintf(toAppend,"%s",tmpMap->value);
+	  }else{
+	    char *tmp3=zStrdup(toAppend);
+	    toAppend=(char*)realloc(toAppend,(strlen(tmpMap->value)+strlen(tmp3)+2)*sizeof(char));
+	    sprintf(toAppend,"%s,%s",tmp3,tmpMap->value);
+	    free(tmp3);
+	  }
+	}
+	free(tmp1);
+	cnt+=1;
+	token = strtok_r (NULL, ",", &saveptr);
+      }
+    }
+    free(tmp);
+  }
+  if(toAppend!=NULL){
+    char *tmp3=zStrdup(res);
+    res=(char*)realloc(res,(strlen(tmp3)+strlen(toAppend)+1)*sizeof(char));
+    sprintf(res,"%s%s",tmp3,toAppend);
+    free(tmp3);
+    free(toAppend);
+  }
+  return res;
+}
+
+/**
  * Cache a file for a given request.
  * For each cached file, the are two files stored, a .zca and a .zcm containing
@@ -80,39 +146,55 @@
   map* tmp=getMapFromMaps(conf,"main","cacheDir");
   if(tmp!=NULL){
-    char* md5str=getMd5(request);
+    char* myRequest=getFilenameForRequest(conf,request);
+    char* md5str=getMd5(myRequest);
+    free(myRequest);
     char* fname=(char*)malloc(sizeof(char)*(strlen(tmp->value)+strlen(md5str)+6));
     sprintf(fname,"%s/%s.zca",tmp->value,md5str);
+    zooLock* lck=lockFile(conf,fname,'w');
+    if(lck!=NULL){
 #ifdef DEBUG
-    fprintf(stderr,"Cache list : %s\n",fname);
-    fflush(stderr);
+      fprintf(stderr,"Cache list : %s\n",fname);
+      fflush(stderr);
 #endif
-    FILE* fo=fopen(fname,"w+");
-    if(fo==NULL){
+      FILE* fo=fopen(fname,"w+");
+      if(fo==NULL){
 #ifdef DEBUG
-      fprintf (stderr, "Failed to open %s for writing: %s\n",fname, strerror(errno));
+	fprintf (stderr, "Failed to open %s for writing: %s\n",fname, strerror(errno));
 #endif
-      filepath = NULL;	
-      return;
-    }
-    fwrite(content,sizeof(char),length,fo);
-    fclose(fo);
+	filepath = NULL;
+	unlockFile(conf,lck);
+	return;
+      }
+      fwrite(content,sizeof(char),length,fo);
+      unlockFile(conf,lck);
+      fclose(fo);
 	
-	if (filepath != NULL) {
-		strncpy(filepath, fname, max_path);
-	}	
-
-    sprintf(fname,"%s/%s.zcm",tmp->value,md5str);
-    fo=fopen(fname,"w+");
+      if (filepath != NULL) {
+	strncpy(filepath, fname, max_path);
+      }
+
+      sprintf(fname,"%s/%s.zcm",tmp->value,md5str);
+      fo=fopen(fname,"w+");
 #ifdef DEBUG
-    fprintf(stderr,"MIMETYPE: %s\n",mimeType);
+      fprintf(stderr,"MIMETYPE: %s\n",mimeType);
 #endif
-    fwrite(mimeType,sizeof(char),strlen(mimeType),fo);
-    fclose(fo);
-
-    free(md5str);
-    free(fname);
+      fwrite(mimeType,sizeof(char),strlen(mimeType),fo);
+      fclose(fo);
+
+      sprintf(fname,"%s/%s.zcp",tmp->value,md5str);
+      fo=fopen(fname,"w+");
+      char* origin=getProvenance(conf,request);
+#ifdef DEBUG
+      fprintf(stderr,"ORIGIN: %s\n",mimeType);
+#endif
+      fwrite(origin,sizeof(char),strlen(origin),fo);
+      fclose(fo);
+
+      free(md5str);
+      free(fname);
+    }
   }
   else {
-	  filepath = NULL;
+    filepath = NULL;
   }	  
 }
@@ -129,5 +211,7 @@
   map* tmpM=getMapFromMaps(conf,"main","cacheDir");
   if(tmpM!=NULL){
-    char* md5str=getMd5(request);
+    char* myRequest=getFilenameForRequest(conf,request);
+    char* md5str=getMd5(myRequest);
+    free(myRequest);
 #ifdef DEBUG
     fprintf(stderr,"MD5STR : (%s)\n\n",md5str);
@@ -206,5 +290,5 @@
       sprintf(xname,"Reference");
       sprintf(bname,"body");
-      sprintf(hname,"headers",i);
+      sprintf(hname,"headers");
       sprintf(oname,"Order");
     }
@@ -280,6 +364,8 @@
 	    free(tmpStr);
 	  }else{
-	    md5str=getMd5(tmp1->value);
+	    char *myRequest=getFilenameForRequest(*m,tmp1->value);
+	    md5str=getMd5(myRequest);
 	    request=zStrdup(tmp1->value);
+	    free(myRequest);
 	  }
 	  char* fname=(char*)malloc(sizeof(char)*(strlen(tmp->value)+strlen(md5str)+6));
@@ -387,8 +473,10 @@
 
   if(cached!=NULL){
-
     struct stat f_status;
     int s=stat(cached, &f_status);
     if(s==0){
+      zooLock* lck=lockFile(*m,cached,'r');
+      if(lck==NULL)
+	return -1;
       fcontent=(char*)malloc(sizeof(char)*(f_status.st_size+1));
       FILE* f=fopen(cached,"rb");
@@ -398,8 +486,12 @@
       fclose(f);
       addToMap(*content,"cache_file",cached);
+      unlockFile(*m,lck);
     }
     cached[strlen(cached)-1]='m';
     s=stat(cached, &f_status);
     if(s==0){
+      zooLock* lck=lockFile(*m,cached,'r');
+      if(lck==NULL)
+	return -1;
       mimeType=(char*)malloc(sizeof(char)*(f_status.st_size+1));
       FILE* f=fopen(cached,"rb");
@@ -407,6 +499,6 @@
       mimeType[f_status.st_size]=0;
       fclose(f);
-    }
-
+      unlockFile(*m,lck);
+    }
   }else{    
     addRequestToQueue(m,hInternet,url,true);
@@ -439,5 +531,7 @@
     if(tmp!=NULL){
       map *c=getMap((*content),"xlink:href");
-      char* md5str=getMd5(c->value);
+      char *myRequest=getFilenameForRequest(*m,c->value);
+      char* md5str=getMd5(myRequest);
+      free(myRequest);
       char* fname=(char*)malloc(sizeof(char)*(strlen(tmp->value)+strlen(md5str)+6));
       sprintf(fname,"%s/%s.zca",tmp->value,md5str);
Index: /branches/prototype-v0/zoo-project/zoo-kernel/meta_sql.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/meta_sql.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/meta_sql.c	(revision 854)
@@ -297,6 +297,4 @@
  */
 elements* extractInput(maps* conf,OGRFeature *input){
-  fprintf(stderr,"************************* %s %s %d\n\n",input->GetFieldAsString( 0 ),__FILE__,__LINE__);
-  fprintf(stderr,"************************* %s %s %d\n\n",input->GetFieldAsString( 1 ),__FILE__,__LINE__);
   elements* res=createElements(input->GetFieldAsString( 1 ));
   res->content=createMap("title",input->GetFieldAsString( 2 ));
@@ -348,8 +346,4 @@
   fillMetadata(conf,&res->metadata,output->GetFieldAsString( 0 ));
   fillAdditionalParameters(conf,&res->additional_parameters,output->GetFieldAsString( 0 ));
-  res->defaults=NULL;
-  res->supported=NULL;
-  res->child=NULL;
-  res->next=NULL;
   int ioCnt=fillLiteralData(conf,res,output,"Output");
   if(ioCnt==0)
@@ -361,5 +355,5 @@
   free(nestedOutputsQuery);
   while( (noutput = noutputs->GetNextFeature()) != NULL ){
-    elements* nout=extractInput(conf,noutput);
+    elements* nout=extractOutput(conf,noutput);
     addToElements(&res->child,nout);
     freeElements(&nout);
@@ -413,8 +407,5 @@
 	elements* in=extractInput(conf,input);
 	if(in!=NULL){
-	  if(s->inputs==NULL)
-	    s->inputs=dupElements(in);
-	  else
-	    addToElements(&s->inputs,in);
+	  addToElements(&s->inputs,in);
 	  freeElements(&in);
 	  free(in);
@@ -431,10 +422,9 @@
       while( (output = outputs->GetNextFeature()) != NULL ){
 	elements* in=extractOutput(conf,output);
-	if(s->outputs==NULL)
-	  s->outputs=dupElements(in);
-	else
+	if(in!=NULL){
 	  addToElements(&s->outputs,in);
-	freeElements(&in);
-	free(in);
+	  freeElements(&in);
+	  free(in);
+	}
 	OGRFeature::DestroyFeature( output );
       }
@@ -463,6 +453,6 @@
 				     service *), int minimal ){
   int result=0;
-  _init_sql(conf,"metadb");
-  if(getMapFromMaps(conf,"lenv","dbIssue")!=NULL)
+  result=_init_sql(conf,"metadb");
+  if(getMapFromMaps(conf,"lenv","dbIssue")!=NULL || result < 0)
     return -1;
   // Fetch every services
Index: /branches/prototype-v0/zoo-project/zoo-kernel/mimetypes.h
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/mimetypes.h	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/mimetypes.h	(revision 854)
@@ -818,21 +818,22 @@
 */
 static map* getFileExtensionMap(const char* mimeType, bool* hasExt) {
-
-	map* ext = createMap("extension", "txt");
-	*hasExt = false;
+  map* ext = createMap("extension", "txt");
+  *hasExt = false;
 	
-	if (mimeType != NULL) { 	
-		for (int i = 0; i < NUM_MIME_TYPES; i++) {			
-			if 	(strncmp(mimeType, MIME[i][M_Type], strlen(MIME[i][M_Type])) == 0) {
-				ext->value = zStrdup(MIME[i][M_Extension]);
-				*hasExt = true;
-				break;				
-			}		
-		}
-		if (*hasExt == false && strncmp(mimeType, "image/", 6) == 0) {
-			ext->value = zStrdup(strstr(mimeType, "/") + 1);
-		}			
-	}	
-	return ext;
+  if (mimeType != NULL) { 	
+    for (int i = 0; i < NUM_MIME_TYPES; i++) {			
+      if(strncmp(mimeType, MIME[i][M_Type], strlen(MIME[i][M_Type])) == 0) {
+	free(ext->value);
+	ext->value = zStrdup(MIME[i][M_Extension]);
+	*hasExt = true;
+	break;				
+      }	
+    }
+    if (*hasExt == false && strncmp(mimeType, "image/", 6) == 0) {
+      free(ext->value);
+      ext->value = zStrdup(strstr(mimeType, "/") + 1);
+    }
+  }	
+  return ext;
 }
 
Index: /branches/prototype-v0/zoo-project/zoo-kernel/request_parser.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/request_parser.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/request_parser.c	(revision 854)
@@ -1849,2 +1849,40 @@
   }
 }
+
+/**
+ * Parse cookie contained in request headers.
+ *
+ * @param conf the conf maps containinfg the main.cfg
+ * @param cookie the 
+ */
+void parseCookie(maps** conf,const char* cookie){
+  char* tcook=zStrdup(cookie);
+  char *token, *saveptr;
+  token = strtok_r (tcook, "; ", &saveptr);
+  maps* res=createMaps("cookies");
+  while (token != NULL){
+    char *token1, *saveptr1, *name;
+    int i=0;
+    token1 = strtok_r (token, "=", &saveptr1);
+    while (token1 != NULL){
+      if(i==0){
+	name=zStrdup(token1);
+	i++;
+      }
+      else{
+	if(res->content==NULL)
+	  res->content=createMap(name,token1);
+	else
+	  addToMap(res->content,name,token1);
+	free(name);
+	i=0;
+      }
+      token1 = strtok_r (NULL, "=", &saveptr1);
+    }
+    token = strtok_r (NULL, "; ", &saveptr);
+  }
+  addMapsToMaps(conf,res);
+  freeMaps(&res);
+  free(res);
+  free(tcook);
+}
Index: /branches/prototype-v0/zoo-project/zoo-kernel/request_parser.h
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/request_parser.h	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/request_parser.h	(revision 854)
@@ -49,5 +49,6 @@
   void checkValidValue(map*,map**,const char*,const char**,int);
   int validateRequest(maps**,service*,map*,maps**,maps**,HINTERNET*);
-
+  void parseCookie(maps**,const char*);
+  
 #ifdef __cplusplus
 }
Index: /branches/prototype-v0/zoo-project/zoo-kernel/response_print.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/response_print.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/response_print.c	(revision 854)
@@ -743,5 +743,13 @@
 }
 
-int addMetadata(map* meta,xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_ows,xmlNsPtr ns_xlink){
+/**
+ * Add a Metadata node to any existing node.
+ * @param meta the map defining the additional parameters
+ * @param doc the XML document used
+ * @param nb the node to add the additional parameters
+ * @param ns_ows the OWS namespace
+ * @param ns_xlink the xlink namespace
+ */
+void addMetadata(map* meta,xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_ows,xmlNsPtr ns_xlink){
     int hasTitle=-1;
     int hasValue=-1;
@@ -817,14 +825,30 @@
 }
 
-
-int addAdditionalParameters(map* meta,xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_ows,xmlNsPtr ns_xlink,int fromDb){
+/**
+ * Add AdditionalParameters nodes to any existing node.
+ * @param meta the map defining the additional parameters
+ * @param doc the XML document used
+ * @param nb the node to add the additional parameters
+ * @param ns_ows the OWS namespace
+ * @param ns_xlink the xlink namespace
+ * @param fromDb 1 if the metadata has been extracted from the metadb, 
+ * 0 otherwise
+ */
+void addAdditionalParameters(map* meta,xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_ows,xmlNsPtr ns_xlink,int fromDb){
     int hasTitle=-1;
     int hasValue=-1;
+    int toAddAtEnd=-1;
+    int cnt=0;
+    xmlNodePtr* ncr=NULL;
     xmlNodePtr nc1;
     map* oMeta=meta;
     int isAdditionalParameters=-1;
-    //if(count(oMeta)>=2){
     int level=0;
     map* test=getMap(meta,"title");
+    map* otitle=getMap(meta,"title");
+    map* length=getMap(meta,"length");
+    int len=0;
+    char *ctitle=NULL;
+    
     if(test!=NULL)
       level+=1;
@@ -837,10 +861,9 @@
     if(count(oMeta)>level+1)
       isAdditionalParameters=1;
-    //}
-    char *ctitle=NULL;
+
     while(meta!=NULL){
-      if(hasTitle<0)
-	if(hasValue<0)
-	  nc1 = xmlNewNode(ns_ows, BAD_CAST "AdditionalParameters");
+      if(hasTitle<0 && hasValue<0){
+	nc1 = xmlNewNode(ns_ows, BAD_CAST "AdditionalParameters");
+      }
       if(strncasecmp(meta->name,"title",5)==0 ||
 	 strcasecmp(meta->name,"href")==0 ||
@@ -851,8 +874,12 @@
 	  hasTitle=1;
 	  if(ctitle!=NULL && strcasecmp(meta->value,ctitle)!=0){
-	      xmlAddChild(nc,nc1);
-	      nc1 = xmlNewNode(ns_ows, BAD_CAST "AdditionalParameters");
-	      free(ctitle);
-	      ctitle=NULL;
+	    xmlNodePtr ncTmp = xmlDocCopyNodeList(doc,nc1);
+	    xmlAddChild(nc,ncTmp);
+	    xmlFreeNode(nc1);
+	    toAddAtEnd=1;
+	    cnt++;
+	    nc1 = xmlNewNode(ns_ows, BAD_CAST "AdditionalParameters");
+	    free(ctitle);
+	    ctitle=NULL;
 	  }
 	  if(ctitle==NULL){
@@ -865,4 +892,6 @@
 	    free(ctitle);
 	  ctitle=zStrdup(meta->value);
+	}else{
+	  xmlNewNsProp(nc1,ns_xlink,BAD_CAST meta->name,BAD_CAST meta->value);
 	}
       }else{
@@ -892,11 +921,17 @@
       meta=meta->next;
       if(hasTitle<0){
-	xmlAddChild(nc,nc1);
+	//xmlAddChild(nc,nc1);
 	hasValue=1;
-      }else
-	free(ctitle);
-    }
-    if(oMeta!=NULL && hasValue<0 && nc1!=NULL){
+      }/*else
+	if(ctitle!=NULL)
+	free(ctitle);*/
+    }
+    if(length!=NULL)
+      len=atoi(length->value);
+    if(otitle!=NULL)
+      len=1;
+    if(cnt<len){
       xmlAddChild(nc,nc1);
+      free(ctitle);
     }
 }
@@ -1406,6 +1441,7 @@
 		  }
 		}
-		else
+		else{
 		  xmlFreeNode(nc9);
+		}
 		if(strcasecmp(tmp1->name,"uom")==0)
 		  hasUOM1=true;
@@ -1428,6 +1464,7 @@
 	    if(hasUOM1==false && vid==0){
 	      xmlFreeNode(nc5);
-	      if(datatype==1)
+	      if(datatype==1){
 		xmlFreeNode(nc4);
+	      }
 	    }
 	    else
@@ -1440,6 +1477,7 @@
 	if(datatype!=1 && default1<0){
 	  xmlFreeNode(nc5);
-	  if(datatype!=2)
+	  if(datatype!=2){
 	    xmlFreeNode(nc4);
+	  }
 	}
 
@@ -1603,9 +1641,11 @@
 		if(vid==0 || oI!=4)
 		  xmlAddChild(nc5,nc6);
-		else
+		else{
 		  xmlFreeNode(nc6);
+		}
 	      }
-	      else
+	      else{
 		xmlFreeNode(nc6);
+	      }
 	    }
 	    tmp1=tmp1->next;
@@ -1634,5 +1674,4 @@
 	    }
 	    else{
-	      xmlFreeNode(nc4);
 	      xmlAddChild(nc3,nc5);
 	    }
@@ -1648,6 +1687,7 @@
 
       if(hasSupported==0){
-	if(datatype==0 && vid!=0)
+	if(datatype==0 && vid!=0){
 	  xmlFreeNode(nc4);
+	}
 	xmlFreeNode(nc5);
       }
@@ -2678,5 +2718,11 @@
       toto=getMap(tmpI->content,"asReference");
 #ifdef USE_MS
-      if(toto!=NULL && strcasecmp(toto->value,"true")==0 && (testMap==NULL || strncasecmp(testMap->value,"true",4)!=0) )
+      restartNoMS:
+      map* geodatatype=getMap(tmpI->content,"geodatatype");
+      
+      if(toto!=NULL && strcasecmp(toto->value,"true")==0 &&
+	 (testMap==NULL ||
+	  strncasecmp(testMap->value,"true",4)!=0 ||
+	  (geodatatype!=NULL && strcasecmp(geodatatype->value,"other")==0) ) ) 
 #else
       if(toto!=NULL && strcasecmp(toto->value,"true")==0)
@@ -2699,7 +2745,7 @@
 	  }
 
+	  char *file_path=NULL;
 	  if(gfile==NULL) {
 	    map *ext=getMap(tmpI->content,"extension");
-	    char *file_path;
 	    char file_ext[32];
 
@@ -2716,5 +2762,5 @@
 	      free(file_name);
 	    file_name=(char*)malloc((strlen(s->name)+strlen(usid->value)+strlen(file_ext)+strlen(tmpI->name)+45)*sizeof(char));
-	    sprintf(file_name,"%s_%s_%s_%d.%s",s->name,tmpI->name,usid->value,itn,file_ext);
+	    sprintf(file_name,"ZOO_DATA_%s_%s_%s_%d.%s",s->name,tmpI->name,usid->value,itn,file_ext);
 	    itn++;
 	    file_path=(char*)malloc((strlen(tmp1->value)+strlen(file_name)+2)*sizeof(char));
@@ -2730,5 +2776,4 @@
 	      return;
 	    }
-	    free(file_path);
 
 	    toto=getMap(tmpI->content,"value");
@@ -2744,10 +2789,9 @@
 	    }
 	    fclose(ofile);
-
 	  }
 
 	  map *tmp2=getMapFromMaps(m,"main","tmpUrl");
 	  map *tmp3=getMapFromMaps(m,"main","serverAddress");
-	  char *file_url;
+	  char *file_url=NULL;
 	  if(strncasecmp(tmp2->value,"http://",7)==0 ||
 	     strncasecmp(tmp2->value,"https://",8)==0){
@@ -2759,6 +2803,18 @@
 	  }
 	  addToMap(tmpI->content,"Reference",file_url);
-	  free(file_name);
-	  free(file_url);
+	  /*maps* curs=tmpI;
+	  curs=curs->next;
+	  map* test=getMap(tmpI->content,"replicateStorageNext");
+	  if(test!=NULL && strncasecmp(test->value,"true",4)==0)
+	    while(curs!=NULL){
+	      addToMap(curs->content,"storage",file_path);
+	      curs=curs->next;
+	      }
+	  if(file_path!=NULL)
+	  free(file_path);*/
+	  if(file_name!=NULL)
+	    free(file_name);
+	  if(file_url!=NULL)
+	    free(file_url);
 	  file_name=NULL;
 	}
@@ -2766,5 +2822,9 @@
       else{
 	if(testMap!=NULL){
+	  setMapInMaps(m,"lenv","state","out");
 	  setReferenceUrl(m,tmpI);
+	  geodatatype=getMap(tmpI->content,"geodatatype");
+	  if(geodatatype!=NULL && strcasecmp(geodatatype->value,"other")==0)
+	    goto restartNoMS;
 	}
       }
Index: /branches/prototype-v0/zoo-project/zoo-kernel/response_print.h
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/response_print.h	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/response_print.h	(revision 854)
@@ -220,6 +220,6 @@
   void printOutputDefinitions(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,maps*,const char*);
   void printStatusInfo(maps*,map*,char*);
-  int addAdditionalParameters(map*,xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,int);
-  int addMetadata(map*,xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr);
+  void addAdditionalParameters(map*,xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,int);
+  void addMetadata(map*,xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr);
 
   void outputResponse(service*,maps*,maps*,map*,int,maps*,int);
Index: /branches/prototype-v0/zoo-project/zoo-kernel/server_internal.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/server_internal.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/server_internal.c	(revision 854)
@@ -26,4 +26,5 @@
 #include "service_internal.h"
 #include "response_print.h"
+#include "service_callback.h"
 #include "mimetypes.h"
 #ifndef WIN32
@@ -444,5 +445,6 @@
 	  if(cSize!=NULL){
 	    length=atoi(cSize->value);
-	  }
+	  }else
+	    length=strlen(cValue->value);
 	  writeFile(val,cValue->value,length);
 	  setMapArray(cMap,"cache_file",k,val);
@@ -466,4 +468,5 @@
 	free(val);
       }
+      addToMap(inputs->content,"byValue","true");
     }
     inputs=inputs->next;
@@ -980,5 +983,5 @@
     if(isRunning(conf,pid)>0){
       if(strncasecmp(req,"GetResult",strlen(req))==0){
-	errorException (conf, _("The result for the requested JobID has not yet been generated. (1)"),
+	errorException (conf, _("The result for the requested JobID has not yet been generated. The service is currently running."),
 			"ResultNotReady", pid);
 	return;
@@ -1008,9 +1011,11 @@
 	  printf("%s",result);
 	  fflush(stdout);
+	  free(sid);
 	  freeMap(&statusInfo);
 	  free(statusInfo);
+	  free(result);
 	  return;
 	}else{
-	  errorException (conf, _("The result for the requested JobID has not yet been generated. (2)"),
+	  errorException (conf, _("The result for the requested JobID has not yet been generated. The service ends but it still needs to produce the outputs."),
 			  "ResultNotReady", pid);
 	  freeMap(&statusInfo);
@@ -1104,4 +1109,9 @@
     removeService(conf,pid);
 #endif
+    /*
+      fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
+      invokeCallback(conf,NULL,NULL,7,1);
+      fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
+    */
     map* statusInfo=createMap("JobID",pid);
     addToMap(statusInfo,"Status","Dismissed");
Index: /branches/prototype-v0/zoo-project/zoo-kernel/service.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/service.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/service.c	(revision 854)
@@ -1172,17 +1172,17 @@
     tmp->name=zStrdup(cursor->name);
     tmp->content=NULL;
-    addMapToMap(&tmp->content,e->content);
+    addMapToMap(&tmp->content,cursor->content);
     tmp->metadata=NULL;
-    addMapToMap(&tmp->metadata,e->metadata);
+    addMapToMap(&tmp->metadata,cursor->metadata);
     tmp->additional_parameters=NULL;
-    addMapToMap(&tmp->additional_parameters,e->additional_parameters);
-    if(e->format!=NULL)
-      tmp->format=zStrdup(e->format);
+    addMapToMap(&tmp->additional_parameters,cursor->additional_parameters);
+    if(cursor->format!=NULL)
+      tmp->format=zStrdup(cursor->format);
     else
       tmp->format=NULL;
-    if(e->defaults!=NULL){
+    if(cursor->defaults!=NULL){
       tmp->defaults=(iotype*)malloc(IOTYPE_SIZE);
       tmp->defaults->content=NULL;
-      addMapToMap(&tmp->defaults->content,e->defaults->content);
+      addMapToMap(&tmp->defaults->content,cursor->defaults->content);
       tmp->defaults->next=NULL;
 #ifdef DEBUG
@@ -1192,10 +1192,10 @@
     }else
       tmp->defaults=NULL;
-    if(e->supported!=NULL){
+    if(cursor->supported!=NULL && cursor->supported->content!=NULL){
       tmp->supported=(iotype*)malloc(IOTYPE_SIZE);
       tmp->supported->content=NULL;
-      addMapToMap(&tmp->supported->content,e->supported->content);
+      addMapToMap(&tmp->supported->content,cursor->supported->content);
       tmp->supported->next=NULL;
-      iotype *tmp2=e->supported->next;
+      iotype *tmp2=cursor->supported->next;
       while(tmp2!=NULL){
 	addMapToIoType(&tmp->supported,tmp2->content);
